From 2ce02fea7b350de9ddfbcf542ba4dd59a8ab255b Mon Sep 17 00:00:00 2001
From: Mans Rullgard <mans@mansr.com>
Date: Wed, 24 Apr 2019 15:08:51 +0100
Subject: [PATCH] fix possible null pointer deref in lsx_make_lpf()
 (CVE-2019-8357)

If the buffer allocation fails, return NULL.
---
 src/effects_i_dsp.c | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/src/effects_i_dsp.c b/src/effects_i_dsp.c
index e32dfa05..88b1b390 100644
--- a/src/effects_i_dsp.c
+++ b/src/effects_i_dsp.c
@@ -362,6 +362,9 @@ double * lsx_make_lpf(int num_taps, double Fc, double beta, double rho,
   assert(Fc >= 0 && Fc <= 1);
   lsx_debug("make_lpf(n=%i Fc=%.7g β=%g ρ=%g dc-norm=%i scale=%g)", num_taps, Fc, beta, rho, dc_norm, scale);
 
+  if (!h)
+    return NULL;
+
   for (i = 0; i <= m / 2; ++i) {
     double z = i - .5 * m, x = z * M_PI, y = z * mult1;
     h[i] = x? sin(Fc * x) / x : Fc;
-- 
2.22.0


